#ifndef ENGINE_ENGINE_NUMBER_9_HTTP_STRUCTURES_CLIENT_REQUEST_H
#define ENGINE_ENGINE_NUMBER_9_HTTP_STRUCTURES_CLIENT_REQUEST_H

#include <vector>
#include <string>
#include <utility>

namespace een9 {
    struct ClientRequest {
        std::string method;
        std::string url;
        std::string http_version;
        std::vector<std::pair<std::string, std::string>> headers;
        bool has_body = false;
        std::string body;
    };
}

#endif
