#ifndef ENGINE_ENGINE_NUMBER_9_HTTP_CLIENT_REQUEST_PARSE_H
#define ENGINE_ENGINE_NUMBER_9_HTTP_CLIENT_REQUEST_PARSE_H

/* Do not export this file */

#include "../baza.h"
#include "client_request.h"


// todo: parse unicode % blocks in url

namespace een9 {
    struct ClientRequestParser {
        ClientRequest& res;

        explicit ClientRequestParser(ClientRequest& res);

        void feedByte(char b);

        bool completed() const;

        bool finished = false;
        /* internal parse data */
        ssize_t i = 0;
        std::string cur_line;
        bool collecting_body = false;
        size_t content_lenth = 0;

        const std::string line_end = "\r\n";
        size_t line_end_progress = 0;

        /* argument stored in cur_line */
        void parseFirstLine();

        void parseHeaderLine();

        void processEndOfHeader();
    };
}

#endif
